﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr164_1
{
    // Абстрактный класс: 
    abstract class Base
    {
        // Защищенное целочисленное поле
        // (указатель на целочисленный массив): 
        protected int[] mas;
        // Конструктор: 
        public Base(int len)
        {
            // Создание массива указанной размерности
            mas = new int[len];
            // Объект для генерирования случайных чисел:
            Random rnd = new Random();
            for (int i = 0; i < len; i++)
            {
                // Значение элемента массива: 
                mas[i] = rnd.Next(20);
            }
        }
        // Целочисленное свойство: 
        public int len_mas
        {
            // Возвращает размер массива
            get
            {
                return mas.Length;
            }
        }
        // Абстрактный метод:
        // выводит содержимое массива
        public abstract void show();
        // Абстрактный индексатор с целочисленным индексом: 
        public abstract int this[int k]
        {
            get;
            set;
        }
    }

    // Производный класс на основе абстрактного: 
    class MyClass: Base {
        // Конструктор
        public MyClass(int n) : base(n) { }
        // Переопределение абстрактного метода: 
        public override void show() 
        {
            for(int k = 0;k < mas.Length; k++) {
                Console.Write("|" + mas[k]);
            }
            Console.WriteLine("|");
        }
        // Переопределение индексатора: 
        public override int this[int k]
        {
            get
            {
                // Значение элемента числового массива: 
                return mas[k];
            }
            set
            {
                // Присваивание значения элементу числового массива: 
                mas[k] = value;
            }
        }
    }

    class Program
    {
        static void Main()
        {
            // Объект для генерирования случайных чисел:
            Random rnd = new Random();
            // Создание объекта:
            MyClass obj = new MyClass(rnd.Next(20));
            // Вывод массива объекта:
            Console.WriteLine("Исходный массив:");
            obj.show();
            // Вывод размера массива:
            Console.WriteLine("Размер массива = " + obj.len_mas);
            // Читаем значение элемента:
            int nom = rnd.Next(5);
            Console.WriteLine("Элемент obj[" + nom + "] = " + obj[nom]);
            // Меняем значение элемента:
            obj[nom] = rnd.Next(20);
            // Снова выводим массив объекта:
            Console.WriteLine("Массив с измененным " + nom + "-м элементом:");
            obj.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
